#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    cin>>t;
    int ans[t];
    for(int i =0; i<t; ++i)
    {
        int n,m;
        ans[i]=1;
        cin>>n>>m;
        long long a[n], b[m], ar[n-1], br[m-1],minn;

        for(int i=0; i<n; ++i)
            cin>>a[i];

        for(int i=0; i<m; ++i)
            cin>>b[i];

        for(int i=1; i<n; ++i)
        {
            ar[i-1]=abs(a[i]-a[i-1]);
            if(i==1)
                minn=ar[i-1];
            else
                minn=min(minn, ar[i-1]);
        }

        for(int i=0; i<n-1; ++i)
        {
            if(ar[i]%minn!=0)
            {
                ans[i]=0;
                break;
            }
        }

        if(ans[i]==0)
            continue;

        for(int i=1; i<m; ++i)
        {
            br[i-1]=abs(b[i]-b[i-1]);
            if(br[i-1]%minn==0)
            {
                ans[i]=0;
            }
        }
    }
    for(int i=0; i<t; ++i)
        cout<<ans[i]<<endl;

    return 0;
}